package cn.estsh.i3plus.pojo.base.enumutil;

/**
 * @author Wynne.Lu
 * @date 2021/3/22 下午5:16
 * @desc
 */
public class ScreenEnumUtil {

    public enum DATA_OBJECT_SOURCE {
        TABLE(10, "TABLE", "数据库表"),
        VIEW(20, "VIEW", "数据库视图");

        private Integer value;
        private String code;
        private String description;

        DATA_OBJECT_SOURCE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum DEFAULT_FIELD_IN_DB {
        CREATE_DATE_TIME("createDatetime", "create_date_time", "创建时间"),
        MODIFY_DATE_TIME("modifyDatetime", "modify_date_time", "修改时间"),
        IS_VALID("isValid", "is_valid", "是否有效"),
        IS_DELETED("isDeleted", "is_deleted", "是否弱删");

        private String code;
        private String codeDb;
        private String description;

        DEFAULT_FIELD_IN_DB(String code, String codeDb, String description) {
            this.code = code;
            this.codeDb = codeDb;
            this.description = description;
        }

        public String getCode() {
            return code;
        }

        public String getCodeDb() {
            return codeDb;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum LAYOUT_TYPE {
        SCREEN(10, "SCREEN", "Screen布局"),
        PANEL(20, "PANEL", "Panel布局");

        private Integer value;
        private String code;
        private String description;

        LAYOUT_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum DATASOURCE_CONNECTION_STATUS {
        SUCCESS(10, "success", "连接成功"),
        FAILED(20, "failed", "连接失败");

        private Integer value;
        private String code;
        private String description;

        DATASOURCE_CONNECTION_STATUS(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum ACTION {
        SEARCH(10, "search", "查询", "scrSearchActionStrategy"),
        CREATE(20, "create", "保存", "scrCreateActionStrategy"),
        UPDATE(30, "update", "更新", "scrUpdateActionStrategy"),
        DELETE(40, "delete", "删除", "scrDeleteActionStrategy"),
        VALID(50, "valid", "启用", "scrValidActionStrategy"),
        INVALID(60, "invalid", "禁用", "scrInvalidActionStrategy"),
        SEARCH_PAGER(70, "searchPager", "分页查询", "scrSearchPagerActionStrategy"),
        ENUM(80, "enum", "枚举查询", "scrEnumActionStrategy"),
        DIRECT(90, "direct", "跳转", "scrDirectActionStrategy"),
        DOWNLOAD(100, "download", "下载", "scrDownloadActionStrategy"),
        UPLOAD(110, "upload", "上传", "scrUploadActionStrategy"),
        INVOKE(120, "invoke", "调用", "scrInvokeActionStrategy");

        private Integer value;
        private String code;
        private String description;
        private String beanName;

        ACTION(Integer value, String code, String description, String beanName) {
            this.value = value;
            this.code = code;
            this.description = description;
            this.beanName = beanName;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String beanOfCode(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equalsIgnoreCase(code)) {
                    tmp = values()[i].beanName;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }


    public enum COMMUNICATION_TYPE {
        HTTP(10, "HTTP", "Http"),
        WEBSOCKET(20, "WEBSOCKET", "WebSocket");

        private Integer value;
        private String code;
        private String description;

        COMMUNICATION_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    public enum DATA_RESOURCE_TYPE {
        ENUM(10, "enum", "枚举"),
        WEBSOCKET(20, "WEBSOCKET", "WebSocket");

        private Integer value;
        private String code;
        private String description;

        DATA_RESOURCE_TYPE(Integer value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public Integer getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }


}
